#include "GUI.h"

#include "my_windows.h"
#include "font.h"
#include "font_6_8.h"

///////////////////////////////////////////////////////////////////////
// class cButton: 
///////////////////////////////////////////////////////////////////////
cButton::cButton( int inX, int inY, int inWidth, int inHeight, long int inColor,
		   char * inLabel, long int inLabelColor, void inActionLeft(),
		   void inActionRight() )
:x (inX), y(inY), width(inWidth), height(inHeight), color(inColor),
 labelColor(inLabelColor), actionLeft(inActionLeft),
 actionRight(inActionRight)
{
	if (inLabel)
	{
		int i = 0;
	    do
		{
			label[i] = inLabel[i];
		}
		while(inLabel[i++]);
	}
}

void
cButton::Draw(Screen& inScreen)
{
	Draw_Filled_Window(inScreen, x, y, width, height, color);
	Draw_String(inScreen, x + 5, y + height/2 - 4, capital_font_6_8, label, labelColor);

}

void
cButton::Check_Mouse(int inX, int inY, bool inLeft)
{
	if (inX >= x && inX <= x + width &&
		inY >= y && inY <= y + height)
	{
		if ( inLeft && actionLeft)
			(*actionLeft)();
		else if (actionRight)
			(*actionRight)();
	}
}

///////////////////////////////////////////////////////////////////////
// class cGUI: 
///////////////////////////////////////////////////////////////////////

cGUI::~cGUI()
{
	while (nrButtons)
	{
		delete mButtons[--nrButtons];
	}
}
void
cGUI::Add_Button(cButton* inButton)
{
	if (nrButtons < MAX_GUI_BUTTONS)
	{
		mButtons[nrButtons++] = inButton;
	}
	else
	{
		delete inButton;
	}
}

	
void
cGUI::Draw(Screen& inScreen)
{
	for (int i = 0; i < nrButtons; i++)
		mButtons[i]->Draw(inScreen);
}

void
cGUI::Check_Mouse(int inX, int inY, bool inLeft)
{
	for (int i = 0; i < nrButtons; i++)
		mButtons[i]->Check_Mouse( inX, inY, inLeft );
}