#ifndef __SEVEN_GUI__
#define __SEVEN_GUI__

#include "screen.h"

///////////////////////////////////////////////////////////////////////
// class cButton:
///////////////////////////////////////////////////////////////////////

enum
{
	MAX_GUI_BUTTONS = 100
};

class cButton
{
public:
  cButton( int inX, int inY, int inLength, int inWidth, long int inColor,
		   char * inLabel, long int inLabelColor, void inActionLeft(),
		   void inActionRight() );

  void		Draw(Screen& inScreen);

  void		Check_Mouse(int inX, int inY, bool inLeft);



private:
  int		x, y, width, height;
  long int	color;
  char		label[256];
  long int	labelColor;
  void      (*actionLeft)();
  void		(*actionRight)();
};

///////////////////////////////////////////////////////////////////////
// class cGUI:
///////////////////////////////////////////////////////////////////////


class cGUI
{ 
public:
	cGUI()	{};
	~cGUI();
	// takes ownership
	void	Add_Button(cButton* inButton);
	void	Draw(Screen& inScreen);
	void	Check_Mouse(int inX, int inY, bool inLeft);	

private:
	int		nrButtons;
	cButton	*mButtons[MAX_GUI_BUTTONS]; // 
};

#endif __SEVEN_GUI__