///////////////////////////////////////////////////////////////////////
// class cIFS_Fractal: 
///////////////////////////////////////////////////////////////////////

#include "IFS_Fractal.h"
#include "affine.h"
#include "stdlib.h"
#include "math.h"


cIFS_Fractal::cIFS_Fractal()
{ int i;

// init to standard sierpinski triangle, non-animated
  double t_mat[9], t_vec[3] = {100, 0, 100}, theTrans[3];

  m_nr_ifs = 3;  
  for (i = 0; i < m_nr_ifs; i++)
  { 
    make_roty_mat(t_mat, i*2*MATH_PI/3);
	mul_mat_vec(t_vec, t_mat, theTrans );
	m_ifs[i].SetTrans( theTrans );
	m_ifs[i].SetColor( IFS_colorLUT[i] );
  }

  SetFullBase();
  SetFullLimit();
}

void cIFS_Fractal::update_limits()
{ int i;
  double factor, maximum, limits[MAX_IFS_TRANSFORMS];

  maximum = 0;
  for( i = 0; i < m_nr_ifs; i++)
  { 
	limits[i] = m_ifs[i].CalcLimit();

	if (limits[i] < 100) limits[i] = 100;
	maximum += limits[i];
  }

  factor = RAND_MAX/maximum;

  maximum = 0;
  for (i = 0; i < m_nr_ifs; i++)
  {	maximum += limits[i];    
    m_limits[i] = (int)(factor * maximum);
  }

  m_limits[m_nr_ifs-1] = RAND_MAX;
}
