#ifndef __SEVEN_IFS_FRACTAL___
#define __SEVEN_IFS_FRACTAL___

#include "my_types.h"
#include "IFS_Transform.h"

enum
{
  MAX_IFS_TRANSFORMS = 50
};

static ulong IFS_colorLUT[] = { 0xFF3F3F, 0x3F3FFF, 0x3FFF3F, 0xFF3FFF, 0xFFFF3F, 0x3FFFFF,
						 0xFFBFBF, 0xBFBFFF, 0xBFFFBF, 0xFFBFFF, 0xFFFFBF, 0xBFFFFF,
						 0xFF0F0F, 0x0F0FFF, 0x0FFF0F, 0xFF0FFF, 0xFFFF0F, 0x0FFFFF,
						 0xBF3F3F, 0x3F3FBF, 0x3FBF3F, 0xBF3FBF, 0xBFBF3F, 0x3FBFBF,
						 0xBF7F7F, 0x7F7FBF, 0x7FBF7F, 0xBF7FBF, 0xBFBF7F, 0x7FBFBF,
						 0xBF0F0F, 0x0F0FBF, 0x0FBF0F, 0xBF0FBF, 0xBFBF0F, 0x0FBFBF,
						 0x7F3F3F, 0x3F3F7F, 0x3F7F3F, 0x7F3F7F, 0x7F7F3F, 0x3F7F7F,
						 0x7F0F0F, 0x0F0F7F, 0x0F7F0F, 0x7F0F7F, 0x7F7F0F, 0x0F7F7F,
						 0x7F7F7F, 0xBFBFBF, 0xFFFFFF };

///////////////////////////////////////////////////////////////////////
// class cIFS_Fractal:
///////////////////////////////////////////////////////////////////////

class cIFS_Fractal
{ 
  public:
    int m_limits[MAX_IFS_TRANSFORMS];
    cIFS_Transform m_ifs[MAX_IFS_TRANSFORMS];
    int m_nr_ifs;
	
// constructors
  cIFS_Fractal();

  void update_limits();
  
  void animate(ulong frame_nr)
  { for (int i = 0; i < m_nr_ifs; i++)
      m_ifs[i].Animate(frame_nr);
  }

  void switch_interpol(int nr, int command)
  { m_ifs[nr].SwitchInterpol(command); }

  void set_base(int nr, int command)
  { m_ifs[nr].SetBase(command); }

  void set_limit(int nr, int command)
  { m_ifs[nr].SetLimit(command); }

  void inc_limit(int nr, int command)
  { m_ifs[nr].IncLimit(command); }

  void dec_limit(int nr, int command)
  { m_ifs[nr].DecLimit(command); }

  void inc_cycle(int nr, int command)
  { m_ifs[nr].IncCycle(command); }

  void dec_cycle(int nr, int command)
  { m_ifs[nr].DecCycle(command); }

  void SetFullBase(void)
  {    
	for (int nr = 0; nr < m_nr_ifs; nr++)	
	  m_ifs[nr].SetFullBase();	
  }

  void SetFullLimit(void)
  {	  
	for (int nr = 0; nr < m_nr_ifs; nr++)
	  m_ifs[nr].SetFullLimit();	 
  }
};

#endif
