#ifndef __SEVEN_IFS_INTERFACE__
#define __SEVEN_IFS_INTERFACE__

#include "my_types.h"
#include "IFS_Fractal.h"
#include "screen.h"
#include "GUI.h"
#include "SDL.h"

///////////////////////////////////////////////////////////////////////
// class cIFS_Interface:
///////////////////////////////////////////////////////////////////////

class cIFS_Interface
{
  public:
    cIFS_Fractal m_f;
	int m_nr_points, m_skip_points,	m_zoom,
	    m_select, m_command,
		m_name_pos, m_merge_colors,
		m_animation;

	double m_view_mat[9],
	       m_view_dx, m_view_dy, m_view_dz,	   // relative
		   m_view_dxa, m_view_dya, m_view_dza; // absolute
	char m_name[16];

  public:
    cIFS_Interface::cIFS_Interface();
	cIFS_Interface::~cIFS_Interface();
    void	Draw(Screen *s);    
    void	Handle_Key(SDL_keysym& k);
	void	Handle_Mouse(SDL_MouseButtonEvent& m);

	static cIFS_Interface*	GetInstance() { return mInstance; }

	void	Create_New_Default_Transform();
	void	Copy_Current_Transform();
	void	Delete_Current_Transform();
	void	Reset_To_2_Cubes();

	void	Stop_Camera_Motion();


    void	DrawHelpScreen(Screen *s);
    
  private:

	cGUI	mGUI;

	

  	bool	mHelpScreen;

	static cIFS_Interface* mInstance;		
};

#endif

