
// yes, I know all the members should be private and accesible via
// get/set methods.. sigh

#ifndef __SEVEN_IFS_TRANSFORM__
#define __SEVEN_IFS_TRANSFORM__

#include "my_types.h"
#include "IFS_Animate.h"

///////////////////////////////////////////////////////////////////////
// class cIFS_Transform: a single transformation plus the
//   associated color
///////////////////////////////////////////////////////////////////////

class cIFS_Transform
{ 	
  public:

// constructors
	cIFS_Transform(void);
	cIFS_Transform(ulong color);

// transformation
	enum {	eScale = 0, 
			eRotate, 
			eSkew, 
			eTrans };
	enum {	eX = 0, 
			eY,
			eZ };

  void			Transform(int inAction, int inAxis, int inAmount);
  void			SetScale( double* inScale );
  const double	GetScale(int i) const { return mScale[i]; }
  void			SetRotate( double* inRotate );
  const double	GetRotate(int i) const { return mRotate[i]; }
  double*		GetRotate() { return mRotate; } // To be removed
  void			SetSkew( double* inSkew );
  const double	GetSkew( int i) const { return mSkew[i]; }
  void			SetTrans( double* inTrans );
  const double	GetTrans( int i) const { return mTrans[i]; }
  double*		GetTrans() { return mTrans; } // To be removed
  void			SetColor(int inColor) { mColor = inColor; }
  int			GetColor() { return mColor; }
  void			Reset();


// animation stuff
	void Animate(ulong frame_nr);
	void SetFullBase(void);		
	void SetFullLimit(void);
	void SwitchInterpol(int command);
	void SetBase(int command);
	void SetLimit(int command);
	void IncLimit(int command);
	void DecLimit(int command);
	double CalcLimit();

	void IncCycle(int command);
	void DecCycle(int command);

 private:
    double mScale[3],	// orthogonal scaling factors
	       mSkew[3],
		   mRotate[9],	// rotation matrix (ortogonal)
		   mTrans[3];	// translation
		   	            
           
    ulong mColor;

 public:

	double mMatrix[9]; // combined
		   

	cIFS_Anim mAnim;	// Animation data
};

#endif

