#include "IFS_IO.h"
#include "Stdio.h"


static FILE * IFS_file;

void write_transform(cIFS_Transform *t)
{ int i;

  for (i = 0; i < 3 ; i++)
    fprintf(IFS_file, " %f", t->GetScale(i));
  for (i = 0; i < 3 ; i++)
    fprintf(IFS_file, " %f", t->GetSkew(i));
  for (i = 0; i < 9 ; i++)
    fprintf(IFS_file, " %f", t->GetRotate(i));
  for (i = 0; i < 3 ; i++)
    fprintf(IFS_file, " %f", t->GetTrans(i));
}

void write_animation(cIFS_Anim *a)
{ int i, j;

  for (i = 0; i < 4; i++)
	for (j = 0; j < 3; j++)
	{
	  fprintf(IFS_file, " %d", a->mSine[i][j]);
	  fprintf(IFS_file, " %d", a->mCycle[i][j]);
	  fprintf(IFS_file, " %f", a->mBase[i][j]);
	  fprintf(IFS_file, " %f", a->mLimit[i][j]);
	}

  for (i = 0; i < 9; i++) fprintf(IFS_file, " %f", a->mRotate[i]);
}

void save_fractal(cIFS_Fractal *ifs, char *name)
{ 
  IFS_file = fopen(name, "w");
  if (IFS_file)
  {
	fprintf(IFS_file, " %d", ifs->m_nr_ifs);
	for (int i = 0; i < ifs->m_nr_ifs; i++)
	  write_transform(&(ifs->m_ifs[i]));
	fclose(IFS_file);  

	name[9] = 'A';
	name[10] = 'N';
	name[11] = 'I';

	IFS_file = fopen(name, "w");
	if (IFS_file)
	{ for (int i = 0; i < ifs->m_nr_ifs; i++)
		write_animation(&(ifs->m_ifs[i].mAnim));
	  fclose(IFS_file);
	}
	name[9] = 'I';
	name[10] = 'F';
	name[11] = 'S';
  }
}

void read_transform(cIFS_Transform *t)
{ int i;
  float temp;

  double theVector[3], theMatrix[9];

  for (i = 0; i < 3 ; i++)
  { fscanf(IFS_file, " %f", &temp);    
	theVector[i] = temp;
  }
  t->SetScale(theVector);

  for (i = 0; i < 3 ; i++)
  { fscanf(IFS_file, " %f", &temp);
	theVector[i] = temp;   
  }
  t->SetSkew(theVector);

  for (i = 0; i < 9 ; i++)
  { fscanf(IFS_file, " %f", &temp);
    theMatrix[i] = temp;
  }
  t->SetRotate(theMatrix);

  for (i = 0; i < 3 ; i++)
  { fscanf(IFS_file, " %f", &temp);
    theVector[i] = temp;   
  }
  t->SetTrans(theVector);
}

void read_animation(cIFS_Anim *a)
{ int i, j;
  float temp;

  for (i = 0; i < 4 ; i++)
    for (j = 0; j < 3; j++)
	{ fscanf(IFS_file, " %d", &(a->mSine[i][j]));
	  fscanf(IFS_file, " %d", &(a->mCycle[i][j]));
	  fscanf(IFS_file, " %f", &temp);
	  a->mBase[i][j] = temp;
	  fscanf(IFS_file, " %f", &temp);
	  a->mLimit[i][j] = temp;
	}

  for (i = 0; i < 9 ; i++)
  {
    fscanf(IFS_file, " %f", &temp);
	a->mRotate[i] = temp;
  }

}

void load_fractal(cIFS_Fractal *ifs, char *name)
{ 
  IFS_file = fopen(name, "r");
  if (IFS_file)
  { fscanf(IFS_file, " %d", &(ifs->m_nr_ifs));
	for (int i = 0; i < ifs->m_nr_ifs; i++)
	{ read_transform(&(ifs->m_ifs[i]));
	  ifs->m_ifs[i].SetColor( IFS_colorLUT[i] );
	}
	fclose(IFS_file);

	name[9] = 'A';
	name[10] = 'N';
	name[11] = 'I';

	IFS_file = fopen(name, "r");
	if (IFS_file)
	{ for (int i = 0; i < ifs->m_nr_ifs; i++)
		read_animation(&(ifs->m_ifs[i].mAnim));
	  fclose(IFS_file);
	}
	else
	{ for (int k = 0; k < ifs->m_nr_ifs; k++)
		for (int i = 0; i < 4; i++)
		  for (int j = 0; j < 3; j++)		  
			ifs->m_ifs[k].mAnim.mSine[i][j] = 1;
	  ifs->SetFullBase();
	  ifs->SetFullLimit();
	}
	name[9] = 'I';
	name[10] = 'F';
	name[11] = 'S';
  }
}
