
#include "font.h"

void Draw_Char(const Screen& s, int x, int y, Font font, uchar ch, int32 color)
{
  uchar *source;
  int32 *dest;
  int i, j;

  if (font.pos[ch] != 0xFF)
  {
    source = font.pic + font.pos[ch]*font.cx*font.cy;
	dest = s.start + y*s.pitch + x;

	for (j = font.cy; j--;)
	{
	  for (i = font.cx; i--;)
	  { if (*(source++)) *dest = color;
	    dest++;
	  }
	  dest += s.pitch - font.cx;
	}
  }
}

void Draw_String(const Screen& s, int x, int y, Font font, char* msg, int32 color)
{
  while (*msg)
  { 
    Draw_Char(s, x, y, font, (uchar)*msg, color);
	x += font.cx + 1;
	msg++;
  }
}
