#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <string.h>
//#include <libiberty.h>
#include "SDL.h"

#include "screen.h"
#include "IFS_Interface.h"


/* The screen surface */
SDL_Surface *screen = NULL;

cIFS_Interface theInterface;


/* This function draws to the screen; replace this with your own code! */
static void
draw ()
{
     SDL_LockSurface(screen);

    Screen myScreen;
    myScreen.start = (int32 *)screen->pixels;
    myScreen.pitch = screen->pitch/4;
    myScreen.cx = 800;
    myScreen.cy = 620;
    myScreen.clipUp = 0;
    myScreen.clipLeft = 0;
    myScreen.clipRight = 799;
    myScreen.clipDown = 619;    
    
    theInterface.Draw(&myScreen);
    
   
   SDL_UnlockSurface(screen);
    /* Make sure everything is displayed on screen */
    SDL_Flip (screen);
    /* Don't run too fast */
    SDL_Delay (1);
}


int
main (int argc, char *argv[])
{
    char msg[] = "Error!";
    int done;

    /* Initialize SDL */
    if (SDL_Init (SDL_INIT_VIDEO) < 0)
    {
        //asprintf (&msg, "Couldn't initialize SDL: %s\n", SDL_GetError ());
        MessageBox (0, msg, "Error", MB_ICONHAND);
        free (msg);
        exit (1);
    }
    atexit (SDL_Quit);

    /* Set 32-bits video mode */
    screen = SDL_SetVideoMode (800, 620, 32, SDL_HWSURFACE | SDL_DOUBLEBUF);
    if (screen == NULL)
    {
        //asprintf (&msg, "Couldn't set 800x600x32 video mode: %s\n",
        //  SDL_GetError ());
        MessageBox (0, msg, "Error", MB_ICONHAND);
        free (msg);
        exit (2);
    }
    SDL_WM_SetCaption ("3D IFS Fractal Editor", NULL);

    SDL_EnableKeyRepeat(400, 80);
    
    done = 0;
    while (!done)
    {
        SDL_Event event;

        /* Check for events */
        while (SDL_PollEvent (&event))
        {
            switch (event.type)
            {
            case SDL_KEYDOWN:
                if ( event.key.keysym.sym != SDLK_ESCAPE )     	
    				theInterface.Handle_Key(event.key.keysym);
				else
					done = 1;
                break;
			case SDL_MOUSEBUTTONDOWN:
				theInterface.Handle_Mouse(event.button);
				break;

            case SDL_QUIT:
                done = 1;
                break;
            default:
                break;
            }
        }

        /* Draw to screen */
        draw ();
    }

    return 0;
}
