/**** Window primitives ***********************************************************/

#include "my_windows.h"

void Draw_3D_Border(const Screen& s, int x, int y, int lengthX, int lengthY, int32 color)
{ 
  int32 brightColor, darkColor;
  int red, green, blue;

  red = (color >> 16) & 0xFF;
  green = (color >> 8) & 0xFF;
  blue = color & 0xFF;
  if ((red -= 64) < 0) red = 0;
  if ((green -= 64) < 0) green = 0;
  if ((blue -= 64) < 0) blue = 0;
  darkColor = (red << 16) + (green << 8) + blue;

  red = (color >> 16) & 0xFF;
  green = (color >> 8) & 0xFF;
  blue = color & 0xFF;
  if ((red += 64) > 255 ) red = 255;
  if ((green += 64) > 255) green = 255;
  if ((blue += 64) > 255) blue = 255;
  brightColor = (red << 16) + (green << 8) + blue;

  Horizontal_Line(s, x, y, lengthX, brightColor);
  Vertical_Line(s, x, y, lengthY, brightColor);
  Horizontal_Line(s, x, y + lengthY - 1, lengthX, darkColor);
  Vertical_Line(s, x+lengthX - 1, y, lengthY, darkColor);

  Horizontal_Line(s, x+1, y+1, lengthX-2, color);
  Vertical_Line(s, x+1, y+1, lengthY-2, color);
  Horizontal_Line(s, x+1, y + lengthY - 2, lengthX-2, color);
  Vertical_Line(s, x+lengthX - 2, y+1, lengthY-2, color);

  Horizontal_Line(s, x+2, y+2, lengthX-4, darkColor);
  Vertical_Line(s, x+2, y+2, lengthY-4, darkColor);
  Horizontal_Line(s, x+2, y + lengthY - 3, lengthX-4, brightColor);
  Vertical_Line(s, x+lengthX - 3, y+2, lengthY-4, brightColor);
}

void Draw_Window(Screen s, int x, int y, int lengthX, int lengthY, int32 color)
{
  Draw_3D_Border(s, x, y, lengthX, lengthY, color);
  Draw_Box(s, x+3, y+3, lengthX-6, lengthY-6, 0);
}

void Draw_Filled_Window(Screen s, int x, int y, int lengthX, int lengthY, int32 color)
{
  Draw_3D_Border(s, x, y, lengthX, lengthY, color);
  Draw_Box(s, x+3, y+3, lengthX-6, lengthY-6, color);
}
